unit uMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  OpenGLContext, gl, glu, ImagingOpenGL;

type

  { TfrmMain }

  TfrmMain = class(TForm)
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure OpenGLControl1Paint(Sender: TObject);
    procedure OpenGLControl1Resize(Sender: TObject);
    procedure OnAppIdle(Sender: TObject; var Done: Boolean);
  private
    { private declarations }
  public
    { public declarations }
		OpenGLControl: TOpenGLControl;
    cube_rotationx: GLFloat;
    cube_rotationy: GLFloat;
    cube_rotationz: GLFloat;
    Textures: array[1..6] of GLuint;
    Activated: Boolean;
    procedure InitializeGL;
  end;

var
  frmMain: TfrmMain;

implementation

procedure TfrmMain.FormActivate(Sender: TObject);
begin
  if not Activated then
  begin
	  InitializeGL;
  	Activated := True;
  end;
end;


{$R *.lfm}


{ TfrmMain }

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  OpenGLControl := TOpenGLControl.Create(Self);
  with OpenGLControl do begin
    Name:='OpenGLControl';
    Align:=alClient;
    Parent:=Self;
    OnPaint:=@OpenGLControl1Paint;
    OnResize:=@OpenGLControl1Resize;
    AutoResizeViewport:=true;
  end;
  Application.AddOnIdleHandler(@OnAppIdle);
end;

procedure TfrmMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
	if Key = 27 then Close;
end;

procedure TfrmMain.OpenGLControl1Paint(Sender: TObject);
var
  Speed: Double;
begin
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(45.0, double(width) / height, 0.1, 100.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glTranslatef(0.0, 0.0,-6.0);

  glColor3f(1.0,1.0,1.0);
	glBindTexture(GL_TEXTURE_2D, Textures[4]);
  glBegin(GL_QUADS);
		glTexCoord2f(0, 0);
  	glVertex3f(-2.5, 2.0, 1);

    glTexCoord2f(1, 0);
  	glVertex3f(-0.5, 2.0, 1);

    glTexCoord2f(1, 1);
  	glVertex3f(-0.5, 0.0, 1);

		glTexCoord2f(0, 1);
  	glVertex3f(-2.5, 0.0, 1);
	glEnd();

  glColor3f(1.0,1.0,1.0);
	glBindTexture(GL_TEXTURE_2D, Textures[3]);
  glBegin(GL_QUADS);
		glTexCoord2f(0, 0);
  	glVertex3f(0.5, 2.0, 1);

    glTexCoord2f(1, 0);
  	glVertex3f(2.5, 2.0, 1);

    glTexCoord2f(1, 1);
  	glVertex3f(2.5, 0.0, 1);

		glTexCoord2f(0, 1);
  	glVertex3f(0.5, 0.0, 1);
	glEnd();

  glColor3f(1.0,1.0,1.0);

 // glRotatef(cube_rotationx, cube_rotationy, cube_rotationz, 0.0);
 //
	//glBindTexture(GL_TEXTURE_2D, Textures[3]);
 // glBegin(GL_QUADS);
	//				glTexCoord2f(1, 0);
 //         glVertex3f( 1.5, 1.5,-1.5);                  // Top Right Of The Quad (Top)
 // 				glTexCoord2f(0, 0);
 //         glVertex3f(-1.5, 1.5,-1.5);                  // Top Left Of The Quad (Top)
 // 				glTexCoord2f(0, 1);
 //         glVertex3f(-1.5, 1.5, 1.5);                  // Bottom Left Of The Quad (Top)
 // 				glTexCoord2f(1, 1);
 //         glVertex3f( 1.5, 1.5, 1.5);                  // Bottom Right Of The Quad (Top)
 // glEnd();
	//glBindTexture(GL_TEXTURE_2D, Textures[1]);
 // glBegin(GL_QUADS);
	//				glTexCoord2f(1, 0);
 //         glVertex3f( 1.5,-1.5, 1.5);                  // Top Right Of The Quad (Bottom)
 // 				glTexCoord2f(0, 0);
 //         glVertex3f(-1.5,-1.5, 1.5);                  // Top Left Of The Quad (Bottom)
 // 				glTexCoord2f(0, 1);
 //         glVertex3f(-1.5,-1.5,-1.5);                  // Bottom Left Of The Quad (Bottom)
 // 				glTexCoord2f(1, 1);
 //         glVertex3f( 1.5,-1.5,-1.5);                  // Bottom Right Of The Quad (Bottom)
 // glEnd();
	//glBindTexture(GL_TEXTURE_2D, Textures[2]);
 // glBegin(GL_QUADS);
 // 				glTexCoord2f(1, 0);
 //         glVertex3f( 1.5, 1.5, 1.5);                  // Top Right Of The Quad (Front)
 // 				glTexCoord2f(0, 0);
 //         glVertex3f(-1.5, 1.5, 1.5);                  // Top Left Of The Quad (Front)
 // 				glTexCoord2f(0, 1);
 //         glVertex3f(-1.5,-1.5, 1.5);                  // Bottom Left Of The Quad (Front)
 // 				glTexCoord2f(1, 1);
 //         glVertex3f( 1.5,-1.5, 1.5);                  // Bottom Right Of The Quad (Front)
 // glEnd();
	//glBindTexture(GL_TEXTURE_2D, Textures[3]);
 // glBegin(GL_QUADS);
	//				glTexCoord2f(1, 0);
 //         glVertex3f( 1.5,-1.5,-1.5);                  // Bottom Left Of The Quad (Back)
 // 				glTexCoord2f(0, 0);
 //         glVertex3f(-1.5,-1.5,-1.5);                  // Bottom Right Of The Quad (Back)
 // 				glTexCoord2f(0, 1);
 //         glVertex3f(-1.5, 1.5,-1.5);                  // Top Right Of The Quad (Back)
 // 				glTexCoord2f(1, 1);
 //         glVertex3f( 1.5, 1.5,-1.5);                  // Top Left Of The Quad (Back)
 // glEnd();
	//glBindTexture(GL_TEXTURE_2D, Textures[1]);
 // glBegin(GL_QUADS);
	//				glTexCoord2f(1, 0);
 //         glVertex3f(-1.5, 1.5, 1.5);                  // Top Right Of The Quad (Left)
 // 				glTexCoord2f(0, 0);
 //         glVertex3f(-1.5, 1.5,-1.5);                  // Top Left Of The Quad (Left)
 // 				glTexCoord2f(0, 1);
 //         glVertex3f(-1.5,-1.5,-1.5);                  // Bottom Left Of The Quad (Left)
 // 				glTexCoord2f(1, 1);
 //         glVertex3f(-1.5,-1.5, 1.5);                  // Bottom Right Of The Quad (Left)
 // glEnd();
	//glBindTexture(GL_TEXTURE_2D, Textures[2]);
 // glBegin(GL_QUADS);
	//				glTexCoord2f(1, 0);
 //         glVertex3f( 1.5, 1.5,-1.5);                  // Top Right Of The Quad (Right)
 // 				glTexCoord2f(0, 0);
 //         glVertex3f( 1.5, 1.5, 1.5);                  // Top Left Of The Quad (Right)
 // 				glTexCoord2f(0, 1);
 //         glVertex3f( 1.5,-1.5, 1.5);                  // Bottom Left Of The Quad (Right)
 // 				glTexCoord2f(1, 1);
 //         glVertex3f( 1.5,-1.5,-1.5);                  // Bottom Right Of The Quad (Right)
 // glEnd();

  Speed := double(OpenGLControl.FrameDiffTimeInMSecs)/100;

  cube_rotationx += 1 * Speed;
  cube_rotationy += 1 * Speed;
  cube_rotationz += 1 * Speed;

  OpenGLControl.SwapBuffers;
end;

procedure TfrmMain.OpenGLControl1Resize(Sender: TObject);
begin
end;

procedure TfrmMain.OnAppIdle(Sender: TObject; var Done: Boolean);
begin
  Done:=false;
  OpenGLControl.Invalidate;
end;

procedure TfrmMain.InitializeGL;
begin
  glClearColor(0.0, 0.0, 0.0, 1.0);
  glEnable(GL_DEPTH_TEST);
  Textures[1] := LoadGLTextureFromFile('Images\Texture1.bmp');
  Textures[2] := LoadGLTextureFromFile('Images\Texture2.bmp');
  Textures[3] := LoadGLTextureFromFile('Images\font_0.bmp');
  Textures[4] := LoadGLTextureFromFile('Images\font_0.png');
  glEnable(GL_TEXTURE_2D);
  //glAlphaFunc( GL_GREATER, 0 );							// set the alpha transparency
  //glEnable( GL_ALPHA_TEST );								// and turn it on
end;

end.

